"use strict";
/******************************************************************************
 * This file was generated by langium-cli 1.1.0.
 * DO NOT EDIT MANUALLY!
 ******************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
exports.reflection = exports.StairwayAstReflection = exports.isOntology = exports.Ontology = exports.isOneToOne = exports.OneToOne = exports.isOneToMany = exports.OneToMany = exports.isModule = exports.Module = exports.isManyToOne = exports.ManyToOne = exports.isManyToMany = exports.ManyToMany = exports.isLocalEntity = exports.LocalEntity = exports.isFunctionMapping = exports.FunctionMapping = exports.isEqualWhen = exports.EqualWhen = exports.isEqual = exports.Equal = exports.isEnumX = exports.EnumX = exports.isEnumEntityAtribute = exports.EnumEntityAtribute = exports.isConfiguration = exports.Configuration = exports.isAttributeEnum = exports.AttributeEnum = exports.isAttribute = exports.Attribute = exports.isApplication = exports.Application = exports.isWhenMapper = exports.WhenMapper = exports.isRelation = exports.Relation = exports.isEntity = exports.Entity = exports.isAttributesMapper = exports.AttributesMapper = exports.isAbstractElement = exports.AbstractElement = void 0;
/* eslint-disable */
const langium_1 = require("langium");
exports.AbstractElement = 'AbstractElement';
function isAbstractElement(item) {
    return exports.reflection.isInstance(item, exports.AbstractElement);
}
exports.isAbstractElement = isAbstractElement;
exports.AttributesMapper = 'AttributesMapper';
function isAttributesMapper(item) {
    return exports.reflection.isInstance(item, exports.AttributesMapper);
}
exports.isAttributesMapper = isAttributesMapper;
exports.Entity = 'Entity';
function isEntity(item) {
    return exports.reflection.isInstance(item, exports.Entity);
}
exports.isEntity = isEntity;
exports.Relation = 'Relation';
function isRelation(item) {
    return exports.reflection.isInstance(item, exports.Relation);
}
exports.isRelation = isRelation;
exports.WhenMapper = 'WhenMapper';
function isWhenMapper(item) {
    return exports.reflection.isInstance(item, exports.WhenMapper);
}
exports.isWhenMapper = isWhenMapper;
exports.Application = 'Application';
function isApplication(item) {
    return exports.reflection.isInstance(item, exports.Application);
}
exports.isApplication = isApplication;
exports.Attribute = 'Attribute';
function isAttribute(item) {
    return exports.reflection.isInstance(item, exports.Attribute);
}
exports.isAttribute = isAttribute;
exports.AttributeEnum = 'AttributeEnum';
function isAttributeEnum(item) {
    return exports.reflection.isInstance(item, exports.AttributeEnum);
}
exports.isAttributeEnum = isAttributeEnum;
exports.Configuration = 'Configuration';
function isConfiguration(item) {
    return exports.reflection.isInstance(item, exports.Configuration);
}
exports.isConfiguration = isConfiguration;
exports.EnumEntityAtribute = 'EnumEntityAtribute';
function isEnumEntityAtribute(item) {
    return exports.reflection.isInstance(item, exports.EnumEntityAtribute);
}
exports.isEnumEntityAtribute = isEnumEntityAtribute;
exports.EnumX = 'EnumX';
function isEnumX(item) {
    return exports.reflection.isInstance(item, exports.EnumX);
}
exports.isEnumX = isEnumX;
exports.Equal = 'Equal';
function isEqual(item) {
    return exports.reflection.isInstance(item, exports.Equal);
}
exports.isEqual = isEqual;
exports.EqualWhen = 'EqualWhen';
function isEqualWhen(item) {
    return exports.reflection.isInstance(item, exports.EqualWhen);
}
exports.isEqualWhen = isEqualWhen;
exports.FunctionMapping = 'FunctionMapping';
function isFunctionMapping(item) {
    return exports.reflection.isInstance(item, exports.FunctionMapping);
}
exports.isFunctionMapping = isFunctionMapping;
exports.LocalEntity = 'LocalEntity';
function isLocalEntity(item) {
    return exports.reflection.isInstance(item, exports.LocalEntity);
}
exports.isLocalEntity = isLocalEntity;
exports.ManyToMany = 'ManyToMany';
function isManyToMany(item) {
    return exports.reflection.isInstance(item, exports.ManyToMany);
}
exports.isManyToMany = isManyToMany;
exports.ManyToOne = 'ManyToOne';
function isManyToOne(item) {
    return exports.reflection.isInstance(item, exports.ManyToOne);
}
exports.isManyToOne = isManyToOne;
exports.Module = 'Module';
function isModule(item) {
    return exports.reflection.isInstance(item, exports.Module);
}
exports.isModule = isModule;
exports.OneToMany = 'OneToMany';
function isOneToMany(item) {
    return exports.reflection.isInstance(item, exports.OneToMany);
}
exports.isOneToMany = isOneToMany;
exports.OneToOne = 'OneToOne';
function isOneToOne(item) {
    return exports.reflection.isInstance(item, exports.OneToOne);
}
exports.isOneToOne = isOneToOne;
exports.Ontology = 'Ontology';
function isOntology(item) {
    return exports.reflection.isInstance(item, exports.Ontology);
}
exports.isOntology = isOntology;
class StairwayAstReflection extends langium_1.AbstractAstReflection {
    getAllTypes() {
        return ['AbstractElement', 'Application', 'Attribute', 'AttributeEnum', 'AttributesMapper', 'Configuration', 'Entity', 'EnumEntityAtribute', 'EnumX', 'Equal', 'EqualWhen', 'FunctionMapping', 'LocalEntity', 'ManyToMany', 'ManyToOne', 'Module', 'OneToMany', 'OneToOne', 'Ontology', 'Relation', 'WhenMapper'];
    }
    computeIsSubtype(subtype, supertype) {
        switch (subtype) {
            case exports.EnumX:
            case exports.Module: {
                return this.isSubtype(exports.AbstractElement, supertype);
            }
            case exports.Equal: {
                return this.isSubtype(exports.AttributesMapper, supertype);
            }
            case exports.EqualWhen: {
                return this.isSubtype(exports.WhenMapper, supertype);
            }
            case exports.LocalEntity: {
                return this.isSubtype(exports.Entity, supertype);
            }
            case exports.ManyToMany:
            case exports.ManyToOne:
            case exports.OneToMany:
            case exports.OneToOne: {
                return this.isSubtype(exports.Relation, supertype);
            }
            default: {
                return false;
            }
        }
    }
    getReferenceType(refInfo) {
        const referenceId = `${refInfo.container.$type}:${refInfo.property}`;
        switch (referenceId) {
            case 'EnumEntityAtribute:type': {
                return exports.EnumX;
            }
            case 'Equal:target': {
                return exports.Attribute;
            }
            case 'LocalEntity:superType':
            case 'ManyToMany:type':
            case 'ManyToOne:type':
            case 'OneToMany:type':
            case 'OneToOne:type': {
                return exports.Entity;
            }
            case 'ManyToMany:by': {
                return exports.LocalEntity;
            }
            default: {
                throw new Error(`${referenceId} is not a valid reference id.`);
            }
        }
    }
    getTypeMetaData(type) {
        switch (type) {
            case 'Application': {
                return {
                    name: 'Application',
                    mandatory: [
                        { name: 'abstractElements', type: 'array' }
                    ]
                };
            }
            case 'Attribute': {
                return {
                    name: 'Attribute',
                    mandatory: [
                        { name: 'unique', type: 'boolean' }
                    ]
                };
            }
            case 'EnumX': {
                return {
                    name: 'EnumX',
                    mandatory: [
                        { name: 'attributes', type: 'array' }
                    ]
                };
            }
            case 'FunctionMapping': {
                return {
                    name: 'FunctionMapping',
                    mandatory: [
                        { name: 'attributemappers', type: 'array' },
                        { name: 'whenmappers', type: 'array' }
                    ]
                };
            }
            case 'LocalEntity': {
                return {
                    name: 'LocalEntity',
                    mandatory: [
                        { name: 'attributes', type: 'array' },
                        { name: 'enumentityatributes', type: 'array' },
                        { name: 'functions', type: 'array' },
                        { name: 'is_abstract', type: 'boolean' },
                        { name: 'relations', type: 'array' }
                    ]
                };
            }
            case 'ManyToMany': {
                return {
                    name: 'ManyToMany',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            case 'ManyToOne': {
                return {
                    name: 'ManyToOne',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            case 'Module': {
                return {
                    name: 'Module',
                    mandatory: [
                        { name: 'elements', type: 'array' }
                    ]
                };
            }
            case 'OneToMany': {
                return {
                    name: 'OneToMany',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            case 'OneToOne': {
                return {
                    name: 'OneToOne',
                    mandatory: [
                        { name: 'create', type: 'boolean' }
                    ]
                };
            }
            default: {
                return {
                    name: type,
                    mandatory: []
                };
            }
        }
    }
}
exports.StairwayAstReflection = StairwayAstReflection;
exports.reflection = new StairwayAstReflection();
//# sourceMappingURL=ast.js.map